/*
    © Copyright 2016 Wouter Meulemans 
    
    This file is part of SMWGComputation.

    SMWGComputation is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    SMWGComputation is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with SMWGComputation.  If not, see <http://www.gnu.org/licenses/>.
*/

/* global URL */

function textBuilder() {
    var tb = {
        string: ""
    };
    
    tb.append = function (str) {
        tb.string += str;
    };
    tb.appendLine = function (str) {
        tb.string += str + "\n";
    };
    
    return tb;
};

function fileBuilderSaver(appendTo, saveAll) {

    var fbs = {};
    var docs = [];  
    var hidden = 0;
    fbs.hiddendoc = function (content, name, type, folder) {
        docs.push({
            name: name,
            content: content,
            folder: folder
        });
        hidden++;
    };    
    fbs.save = function (content, name, type, folder) {
        docs.push({
            name: name,
            content: content,
            folder: folder
        });
        var a = document.createElement("a");
        appendTo.appendChild(a);
        a.style = "display: block;";
        a.href = URL.createObjectURL(new Blob([content], {type: type}));
        a.download = name;
        a.innerHTML = name;
        return a;
    };
    fbs.clear = function () {
        appendTo.innerHTML = "";
        docs = [];
        hidden = 0;
        saveAll.href = null;
        saveAll.download = "";
        saveAll.innerHTML = "";
    };
    fbs.saveAll = function (name) {
        if (docs.length > 0) {
            var zip = new JSZip();
            docs.forEach(function (doc) {
                if (doc.folder === undefined)
                    zip.file(doc.name, doc.content);
                else 
                    zip.folder(doc.folder).file(doc.name, doc.content);
            });
            saveAll.href = URL.createObjectURL(zip.generate({type: "blob"}));
            saveAll.download = (name ? name : "all") + ".zip";
            saveAll.innerHTML = (name ? name : "all") + ".zip [+"+hidden+" hidden]";
        } else {
            saveAll.href = null;
            saveAll.download = "";
            saveAll.innerHTML = "";
        }
        return saveAll;
    };

    return fbs;
};